﻿Imports System.Data
Imports System.Web.UI.DataVisualization.Charting

Partial Class Estadistica_GraficaCrias
    Inherits System.Web.UI.Page
    Dim Animales As New DataSet_mdsTableAdapters.reporteCriasTableAdapter
    Dim utilCalif As New CalificacionesUtil()


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try         
            Dim animal = Request.Params("animal")
            Dim sexo = Request.Params("sexo")

            lblAnimalString.Text = sexo & animal

            Dim DSTientaAP As DataSet_mds.reporteCriasDataTable
            Dim DSTientaAC As DataSet_mds.reporteCriasDataTable
            Dim DSLidiaAP As DataSet_mds.reporteCriasDataTable
            Dim DSLidiaAC As DataSet_mds.reporteCriasDataTable

            If sexo.Equals("T") Then
                DSTientaAP = Animales.getReporteTientaAPByPadre(animal)
                DSTientaAC = Animales.GetReporteTientaACByPadre(animal)
                DSLidiaAP = Animales.GetReporteLidiaAPByPadre(animal)
                DSLidiaAC = Animales.GetReporteLidiaACByPadre(animal)
            ElseIf sexo.Equals("V") Then
                DSTientaAP = Animales.GetReporteTientaAPByMadre(animal)
                DSTientaAC = Animales.GetReporteTientaACByMadre(animal)
                DSLidiaAP = Animales.GetReporteLidiaAPByMadre(animal)
                DSLidiaAC = Animales.GetReporteLidiaACByMadre(animal)
            End If

            Dim Media As Double
            GraficaTienta_AP.DataSource = DSTientaAP
            GraficaTienta_AP.DataBind()
            With GraficaTienta_AP.Series(0)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            With GraficaTienta_AP.Series(1)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            GraficaTienta_AP.DataBind()
            CargarAxisY(GraficaTienta_AP.ChartAreas)
            AgregarPorcentajes(GraficaTienta_AP, DSTientaAP, CaluculaDE("tienta_ap", animal, sexo, "tienta_fecha"))
            GraficaTienta_AP.Legends("Animales").Enabled = False
            Media = GraficaTienta_AP.DataManipulator.Statistics.Mean("TotalAnimales")
            GraficaTienta_AP.ChartAreas("ChartArea1").AxisY.StripLines(0).IntervalOffset = Media

            GraficaTienta_AC.DataSource = DSTientaAC
            GraficaTienta_AC.DataBind()
            With GraficaTienta_AC.Series(0)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            With GraficaTienta_AC.Series(1)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            GraficaTienta_AC.DataBind()
            CargarAxisY(GraficaTienta_AC.ChartAreas)
            AgregarPorcentajes(GraficaTienta_AC, DSTientaAC, CaluculaDE("tienta_ac", animal, sexo, "tienta_fecha"))
            GraficaTienta_AC.Legends("Animales").Enabled = False
            Media = GraficaTienta_AC.DataManipulator.Statistics.Mean("TotalAnimales")
            GraficaTienta_AC.ChartAreas("ChartArea1").AxisY.StripLines(0).IntervalOffset = Media

            GraficaLidia_AP.DataSource = DSLidiaAP
            GraficaLidia_AP.DataBind()
            With GraficaLidia_AP.Series(0)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            With GraficaLidia_AP.Series(1)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            GraficaLidia_AP.DataBind()
            CargarAxisY(GraficaLidia_AP.ChartAreas)
            AgregarPorcentajes(GraficaLidia_AP, DSLidiaAP, CaluculaDE("lidia_ap", animal, sexo, "lidia_fecha"))
            GraficaLidia_AP.Legends("Animales").Enabled = False
            Media = GraficaLidia_AP.DataManipulator.Statistics.Mean("TotalAnimales")
            GraficaLidia_AP.ChartAreas("ChartArea1").AxisY.StripLines(0).IntervalOffset = Media

            GraficaLidia_AC.DataSource = DSLidiaAC
            GraficaLidia_AC.DataBind()
            With GraficaLidia_AC.Series(0)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            With GraficaLidia_AC.Series(1)
                .XValueMember = "ano"
                .YValueMembers = "valorCalificacion"
                .LabelToolTip = "#VALX"
            End With
            GraficaLidia_AC.DataBind()
            CargarAxisY(GraficaLidia_AC.ChartAreas)
            AgregarPorcentajes(GraficaLidia_AC, DSLidiaAC, CaluculaDE("lidia_ac", animal, sexo, "lidia_fecha"))
            GraficaLidia_AC.Legends("Animales").Enabled = False
            Media = GraficaLidia_AC.DataManipulator.Statistics.Mean("TotalAnimales")
            GraficaLidia_AC.ChartAreas("ChartArea1").AxisY.StripLines(0).IntervalOffset = Media
        Catch ex As Exception

        End Try
    End Sub

    Public Sub CargarAxisY(ByRef chartArea As ChartAreaCollection)

         Dim LabelsY As CustomLabelsCollection
        LabelsY = chartArea(0).AxisY.CustomLabels

        LabelsY.Add(0.5, 1.5, "M")
        LabelsY.Add(1.5, 2.5, "-R")
        LabelsY.Add(2.5, 3.5, "R")
        LabelsY.Add(3.5, 4.5, "+R")
        LabelsY.Add(4.5, 5.5, "-B")
        LabelsY.Add(5.5, 6.5, "B")
        LabelsY.Add(6.5, 7.5, "+B")
        LabelsY.Add(7.5, 8.5, "MB")
        LabelsY.Add(8.5, 9.5, "S")

        With chartArea(0)
            .AxisY.Interval = 1
            .AxisY.Minimum = 0
            .AxisY.Maximum = 9
            .AxisY.Title = "Calificaciones"
            .AxisX.Title = "Año"
            .AxisX.MajorGrid.Enabled = False
        End With
    End Sub
    Public Sub AgregarPorcentajes(ByVal dgv As Chart, ByVal dsConsulta As DataTable, ByVal dtDE As DataTable)

        For Each Punto In dgv.Series(0).Points
            For Each Row As DataRow In dsConsulta.Rows
                If (Punto.XValue.ToString = Row.Item("ano").ToString) Then
                    Punto.Label = Row.Item("total")
                    Punto.LabelForeColor = Drawing.Color.White
                End If
            Next
        Next


        For Each Punto In dgv.Series(1).Points
            For Each Row As DataRow In dsConsulta.Rows
                If (Punto.XValue.ToString = Row.Item("ano").ToString) Then
                    Dim iPorcentaje As Integer = 0

                    If (Row.Item("total") > 0) Then
                        iPorcentaje = (Row.Item("animales") / Row.Item("total")) * 100
                    Else
                        iPorcentaje = 0
                    End If
                    Punto.SetCustomProperty("BarLabelStyle", "Center")

                    Dim strQuery As String = "Anio=" & Punto.XValue.ToString
                    Dim strDE As Double
                    For Each dr In dtDE.Select(strQuery)
                        If (dr.Item("DE").ToString.Length > 0) Then
                            strDE = dr.Item("DE")
                        End If
                    Next
                    Punto.Label = Row.Item("calificacion") & "(" & iPorcentaje & "%)" & "(" & strDE.ToString("#.##") & ")"

                End If
            Next
        Next
    End Sub

    Public Function CaluculaDE(ByVal Tipo As String, ByVal padre As String, ByVal sexo As String, ByVal sFecha As String) As DataTable
        Dim sSQL As String
        Dim SqlDs As New SqlDataSource()
        SqlDs.ConnectionString = ConfigurationManager.ConnectionStrings("GanaderiaConnectionString").ConnectionString

        Dim defSexo As String = ""
        If (sexo) = "V" Then
            defSexo = "m"
        Else
            defSexo = "p"
        End If

        sSQL = "SELECT " & _
                         "year(a." & sFecha & ") AS ano, " & _
                        "AVG(c.valor) AS valorCalificacion, " & _
                        "COUNT(a.AnimalId) as total, " & _
                        "(SELECT COUNT(1) FROM dbo.animal WHERE year(" & sFecha & ")=year(a." & sFecha & ")  and (convert(nvarchar(10),no_" & defSexo & "adre)+convert(nvarchar(10),ltra_" & defSexo & "adre)+convert(nvarchar(10),ano_" & defSexo & "adre)) like '" & padre & "' AND (CASE WHEN " & Tipo & " = 'S' THEN 9 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = 'MB' THEN 8 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = '+B' THEN 7 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = 'B' THEN 6 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = '-B' THEN 5 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = '+R' THEN 4 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = 'R' THEN 3 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = '-R' THEN 2 " & _
                                                                                                                                                                                                                                                         "WHEN " & Tipo & " = 'M' THEN 1 " & _
                                                                                                                                                                                                                                                         "END )=AVG(c.valor)) as animales " & _
                        "FROM (SELECT " & _
                                "DISTINCT " & Tipo & ", " & _
                                "CASE " & _
                                    "WHEN " & Tipo & " = 'S' THEN 9 " & _
                                    "WHEN " & Tipo & " = 'MB' THEN 8 " & _
                                    "WHEN " & Tipo & " = '+B' THEN 7 " & _
                                    "WHEN " & Tipo & " = 'B' THEN 6 " & _
                                    "WHEN " & Tipo & " = '-B' THEN 5 " & _
                                    "WHEN " & Tipo & " = '+R' THEN 4 " & _
                                    "WHEN " & Tipo & " = 'R' THEN 3 " & _
                                    "WHEN " & Tipo & " = '-R' THEN 2 " & _
                                    "WHEN " & Tipo & " = 'M' THEN 1 " & _
                                "END AS valor " & _
                            "FROM animal " & _
                            "WHERE " & Tipo & " IN ('S', 'MB', '+B', 'B', '-B', '+R', 'R', '-R', 'M') " & _
                    ") AS c " & _
                        "INNER JOIN animal AS a " & _
                        "ON c." & Tipo & " = a." & Tipo & " " & _
                   "WHERE (convert(nvarchar(10),no_" & defSexo & "adre)+convert(nvarchar(10),ltra_" & defSexo & "adre)+convert(nvarchar(10),ano_" & defSexo & "adre)) like '" & padre & "' " & _
                   " AND year(a." & sFecha & ") IS NOT NULL " & _
                    "GROUP BY year( a." & sFecha & "),c.valor " & _
                    "ORDER BY year(a." & sFecha & "),c.valor "

        SqlDs.SelectCommand = sSQL
        Dim dtDE As New DataTable()
        dtDE.Columns.Add("Anio")
        dtDE.Columns.Add("DE")
        Dim anio As String = ""
        Dim strQuery As String
        Dim listaDatos As New List(Of Double)
        Dim resultset As Data.DataView = CType(SqlDs.Select(DataSourceSelectArguments.Empty), Data.DataView)
        For Each fila As Data.DataRowView In resultset
            anio = fila("ano")
            strQuery = "Anio=" & anio
            If (dtDE.Select(strQuery).Length = 0) Then
                Dim drDe = dtDE.NewRow
                drDe.Item("Anio") = anio
                dtDE.Rows.Add(drDe)
                listaDatos = New List(Of Double)
                listaDatos.Add(fila("animales"))
            Else
                For Each dr In dtDE.Select(strQuery)
                    listaDatos.Add(fila("animales"))
                    dr.Item("DE") = DesviacionStandard(listaDatos)
                Next
            End If
        Next

        Return dtDE
    End Function
    Public Function DesviacionStandard(listaDatos As List(Of Double)) As Double
        Dim desvStd As Double = 0
        Dim N As Double = 0, prom As Double = 0, suma As Double = 0, NrestadoUno As Double = 0, sumapotencias As Double = 0
        N = listaDatos.Count
        NrestadoUno = N - 1
        For Each dato As Double In listaDatos
            suma += dato
        Next
        prom = suma / N
        For Each dato As Double In listaDatos
            sumapotencias += Math.Pow((dato - prom), 2)
        Next
        desvStd = Math.Sqrt((1 * sumapotencias) / NrestadoUno)
        Return desvStd
    End Function
End Class
